import os
import threading
import gobject
import time

from pysqlite2 import dbapi2 as sqlite
from mediaitem import MediaItem

class Database:
    def __init__ (self, basedir, dbname):
        self.basedir = basedir
        self.dbname = dbname

        self.dbpath = os.path.join (self.basedir, self.dbname)
        self.table_desc = \
"CREATE TABLE files (\
 id INTEGER PRIMARY KEY,\
 fullpath VARCHAR(1024),\
 filename VARCHAR(256),\
 content VARCHAR(256),\
 artist VARCHAR(256),\
 album VARCHAR(256),\
 title VARCHAR(256),\
 duration VARCHAR(256),\
 duration_i INTEGER,\
 track_number INTEGER,\
 track_count INTEGER,\
 comment VARCHAR(256),\
 extended_comment VARCHAR(256)\
)"

        # connect and create if not present
        self.connection = sqlite.connect (self.dbpath)
        self.cursor = self.connection.cursor ()

        try:
            self.cursor.execute (self.table_desc)
        except:
            pass

    def insertItem (self, item):
        self.cursor.execute ('INSERT INTO files VALUES (null, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                             (unicode (item.fullpath), 
                              unicode (item.filename),
                              unicode (item.mediacontent), 
                              unicode (item.artist),
                              unicode (item.album),
                              unicode (item.title),
                              unicode (item.duration),
                              item.duration_i,
                              item.track_number,
                              item.track_count,
                              unicode (item.comment),
                              unicode (item.extended_comment)))
        self.connection.commit ()
        return self.cursor.lastrowid

    def getItems (self): 
        items = []
        self.cursor.execute('SELECT * FROM files')

        for row in self.cursor:
            item = MediaItem ()
            item.id = row[0]
            item.fullpath = row[1]
            item.filename = row[2]
            item.mediacontent = row[3]
            item.artist = row[4]
            item.album = row[5]
            item.title = row[6]
            item.duration = row[7]
            item.duration_i = row[8]
            item.track_number = row[9]
            item.track_count = row[10]
            items.append (item)
        return items

    def getItemById (self, id): 
        self.cursor.execute('SELECT * FROM files WHERE id=\"%d\"'%id)

        item = MediaItem ()

        for row in self.cursor:
            if row[0] != id:
                continue
            item.id = row[0]
            item.fullpath = row[1]
            item.filename = row[2]
            item.mediacontent = row[3]
            item.artist = row[4]
            item.album = row[5]
            item.title = row[6]
            item.duration = row[7]
            item.duration_i = row[8]
            item.track_number = row[9]
            item.track_count = row[10]

        if item.fullpath == "":
            return None
        return item

    def updateIdWithItem (self, id, item):
        self.cursor.execute ("UPDATE files SET \
fullpath=\"%s\", filename=\"%s\", content=\"%s\", artist=\"%s\", album=\"%s\", title=\"%s\",\
duration=\"%s\", duration_i=\"%d\", track_number=\"%d\", track_count=\"%d\",\
 comment=\"%s\", extended_comment=\"%s\" WHERE id=\"%d\"" % 
                             (unicode (item.fullpath), 
                              unicode (item.filename),
                              unicode (item.mediacontent), 
                              unicode (item.artist), 
                              unicode (item.album),
                              unicode (item.title),
                              unicode (item.duration),
                              item.duration_i,
                              item.track_number,
                              item.track_count,
                              unicode (item.comment),
                              unicode (item.extended_comment), 
                              id))
        self.connection.commit ()


    def removeById (self, id):
        self.cursor.execute ('DELETE FROM files WHERE id=\"%d\"'%id)
        self.connection.commit ()
        return self.cursor.lastrowid

    def removeByIdList (self, ids):
        if len (ids) == 0:
            return

        for id in ids:
            self.cursor.execute ('DELETE FROM files WHERE id=\"%d\"'%id)
        self.connection.commit ()
        return self.cursor.lastrowid

    def removeAll (self):
        self.cursor.execute ('DELETE FROM files')
        self.connection.commit ()
        return self.cursor.lastrowid
