import urllib
import gio
import re

class Playlist:
    def __init__ (self):
        self.filelist = []

    def addFile (self, file):
        self.filelist.append (file)

    def load (self, uri):
        print "Playlist::load()"
        unquoted_uri = urllib.unquote (uri)

        try:
            fp = gio.File (unquoted_uri)
        except:
            return

        try:
            ctype = fp.query_info ("*").get_content_type ()
            if ctype == "application/octet-stream":
                if unquoted_uri.find (".pls") > 0:
                    ctype = "audio/x-scpls"
                elif unquoted_uri.find (".m3u") > 0:
                    ctype = "audio/x-mpegurl"
                elif unquoted_uri.find (".asx") > 0:
                    ctype = "audio/x-ms-asx"
        except:
            pass

        rs = fp.read ()
        dis = gio.DataInputStream (rs)
        if ctype == "audio/x-mpegurl":
            ret = self._readM3u (dis)
        elif ctype == "audio/x-scpls":
            ret = self._readPls (dis)
        elif ctype == "audio/x-ms-asx":
            ret = self._readAsx (dis)
        else:
            ret = False

        del dis
        del rs
        del fp

        return ret

    def save (self, file):
        fp = open (file, 'w')
        for file in self.filelist:
            fp.write (file)
            fp.write ("\n")
        fp.close ()

    def _readM3u (self, dis):
        line = dis.read_line (None)
        while line:
            print line
            line = line.strip ()
            if line[0] != '#':
                self.filelist.append (line)
            line = dis.read_line (None)
        return True

    def _readPls (self, dis):
        line = dis.read_line (None)
        while line:
            line = line.strip ()
            if line.find ("File") == 0:
                reg = re.compile ('File(.)*=')
#                print reg.sub ('', line)
                self.filelist.append (reg.sub ('', line))
            line = dis.read_line (None)
        return True

    def _readAsx (self, dis):
        line = dis.read_line (None)
        str = ''
        while line:
            line = line.strip ()
            if line.find ("href") > 0:
                reg = re.compile ('<(.)*="|"(.)*/(.)*>')
                self.filelist.append (reg.sub ('', line))
            line = dis.read_line (None)

        return True
